package org.xbib.interlibrary.client.gbv.z;

import org.xbib.datastructures.tiny.TinyMap;
import org.xbib.interlibrary.action.search.SearchRequest;
import org.xbib.interlibrary.action.search.SearchResponse;
import org.xbib.interlibrary.action.search.SearchResponseBuilder;
import org.xbib.interlibrary.api.action.Service;
import org.xbib.interlibrary.api.action.ServiceArguments;
import org.xbib.interlibrary.z.AbstractZSearchService;
import org.xbib.interlibrary.z.DisplayHelper;
import org.xbib.marc.MarcRecord;

import java.util.function.Supplier;

public class ZSearchService extends AbstractZSearchService {

    public ZSearchService(ServiceArguments arguments) {
        super(arguments);
    }

    @Override
    protected boolean fixByOne() {
        return false;
    }

    @Override
    protected void search(SearchRequest request,
                          SearchResponseBuilder response,
                          int recordNumber,
                          MarcRecord marcRecord) {
        Supplier<String> supplier = marcHelper.getRecordIdSupplier(marcRecord);
        TinyMap.Builder<String, Object> builder = TinyMap.builder();
        DisplayHelper.display(builder, marcHelper, marcRecord, getName(), getLabel(), getURL(supplier.get()), supplier);
        builder.put("_index", getName());
        builder.put("_id", Integer.toString(recordNumber));
        builder.put("_leader", marcRecord.getRecordLabel().toString());
        if (request.isSourceEnabled()) {
            builder.put("_source", marcRecord);
        }
        logSource(marcRecord);
        response.add(getName(), builder.build());
    }

    @Override
    public int compareTo(Service<SearchRequest, SearchResponse<SearchRequest>, SearchResponseBuilder> o) {
        return getName().compareTo(o.getName());
    }
}
